* Customer class.

define class Customer as BusinessClass of Layers.fxp olepublic
	cDataProgID = 'Contacts.DataClass'
	Name        = 'Customer'

* Get a customer by ID.

	procedure GetCustomerByID(toRS as Object, tcID as String) as Boolean
		local lcCommand, ;
			llOK
		with This
			.ResetError()
			lcCommand = "select * from Customers where CustomerID = '" + ;
				tcID + "'"
			llOK = .oData.GetRecordSet(toRS, lcCommand)
			if llOK
				llOK = not toRS.EOF
			else
				.ErrorMessage  = .oData.ErrorMessage
				.ErrorOccurred = .T.
			endif llOK
		endwith
		return llOK
	endproc

* Fill the specified recordset with an empty record.

	procedure NewCustomer(toRS as Object) as Boolean
		local llReturn
		with This
			.GetCustomerByID(toRS, '-1')
			llReturn = not .ErrorOccurred
			if llReturn
				toRS.AddNew()
				llReturn = not .ErrorOccurred
			endif llReturn
		endwith
		return llReturn
	endproc

* Set the provider and connection string for the data object.

	protected procedure SetDataProperties
		with This
*!*				.oData.cProvider         = 'Microsoft.Jet.OLEDB.4.0'
*!*				.oData.cConnectionString = 'Data Source=D:\Program Files\' + ;
*!*					'Microsoft Visual Studio\VB98\Nwind.mdb'
			.oData.cProvider         = 'SQLOLEDB.1'
			.oData.cConnectionString = 'Persist Security Info=False;' + ;
				'User ID=sa;Initial Catalog=Northwind;Data Source=(local)'
		endwith
	endproc

* Ensure the specified recordset has valid data.

	protected procedure ValidateData(toRS)
		local llReturn

* This is just a demo, so we won't allow some demo stuff to be done.

		do case
			case toRS.Fields('Fax').Value = '999-999-9999'
				error 'The fax number cannot be 999-999-9999.'
				llReturn = .F.
			otherwise
				llReturn = .T.
		endcase
		return llReturn
	endproc
enddefine

* Orders class

define class Orders as BusinessClass of Layers.fxp olepublic
	cDataProgID = 'Contacts.DataClass'
	Name        = 'Orders'

* Gets the orders for the specified customer.

	procedure GetOrdersForCustomer(toRS as Object, tcCustomerID as String) ;
		as Boolean
		local lcCommand, ;
			llOK
		with This
			.ResetError()
			lcCommand = 'shape {select OrderID, OrderDate, Freight from ' + ;
				"Orders where CustomerID = '" + tcCustomerID + "'} " + ;
				'as Orders append ({select OrderID, ProductName, ' + ;
				'"Order Details".UnitPrice, Quantity, ' + ;
				'"Order Details".UnitPrice * Quantity as LineTotal from ' + ;
				'"Order Details" inner join Products on ' + ;
				'"Order Details".ProductID = Products.ProductID} ' + ;
				'as OrderDetails relate OrderID to OrderID) as OrderDetails'
			llOK = .oData.GetRecordSet(toRS, lcCommand)
			if llOK
				llOK = not toRS.EOF
			else
				.ErrorMessage  = .oData.ErrorMessage
				.ErrorOccurred = .T.
			endif llOK
		endwith
		return llOK
	endproc

* Set the provider and connection string for the data object.

	protected procedure SetDataProperties
		with This
*!*				.oData.cProvider         = 'MSDataShape'
*!*				.oData.cConnectionString = 'Data Source=D:\Program Files\' + ;
*!*					'Microsoft Visual Studio\VB98\Nwind.mdb;' + ;
*!*					'Data Provider=Microsoft.Jet.OLEDB.4.0'
			.oData.cProvider         = 'MSDataShape'
			.oData.cConnectionString = 'Data Provider=SQLOLEDB.1;' + ;
				'Persist Security Info=False;User ID=sa;' + ;
				'Initial Catalog=Northwind;Data Source=(local)'
		endwith
	endproc
enddefine
